	page	,132

;******************************************************************************
;	File:  LOADX.S
;	Project:  Loader for CTRLPGM for SCO Xenix 386
;	Date:  09/30/87 - Release 1.00
;	Author:  taken from Bill Bruce (SCO Xenix 286)
;	Revised:
;	  Release 1.01 - 10/21/87 - Lori Slater
;******************************************************************************

	.xlist
	include	scc.equ
	include	dpram.equ
	.list

data	segment	public 'data'

	public	com_data
com_data	equ	$

; System Processor => Comm Processor queue
	dw	0		; Comq head
	dw	0		; Comq tail
	dw	msgq_mask_value	; Comq mask
	db	msgq_size*msg_len dup (?)

; Comm Processor => System Processor queue
	dw	0		; Sysq head
	dw	0		; Sysq tail
	dw	msgq_mask_value	; Sysq mask
	db	msgq_size*msg_len dup (?)

; line 0
	dw	04h		; base I/O address
	dw	0		; line status
	dw	0		; transmit procedure
	db	80h		; channel reset command
	db	0		; modem status control value

	db	80h		; WR2
	db	0c0h		; WR3
	db	44h		; WR4
	db	60h		; WR5
	db	bps9600		; WR12
	db	bps9600 shr 8	; WR13
	db	0		; WR15

	dw	0		; input modes
	dw	0		; output modes
	dw	0		; control modes
	dw	0		; local modes
	db	0		; line discipline

	dw	0		; Txq head
	dw	0		; Txq tail
	dw	Txb_size-1	; Txq mask
	dw	offset line0_Txb	; Txq buffer offset

	dw	0		; Rxq head
	dw	0		; Rxq tail
	dw	Rxb_size-1	; Rxq mask
	dw	offset line0_Rxb	; Rxq buffer offset

	dw	0		; Auxq head
	dw	0		; Auxq tail
	dw	Auxb_size-1	; Auxq mask
	dw	offset line0_Auxb	; Aux buffer offset

	dw	-1		; primary device data block size
	dw	0		; auxiliary device data block size
	db	_prefix_len dup (?)	; auxiliary device prefix string
	db	_suffix_len dup (?)	; auxiliary device suffix string

	dw	-1		; primary device data count
	dw	0		; auxiliary device data count
	dw	0		; prefix/suffix pointer

; line 1
	dw	00h		; base I/O address
	dw	0		; line status
	dw	0		; transmit procedure
	db	40h		; channel reset command
	db	0		; modem status control value

	db	80h		; WR2
	db	0c0h		; WR3
	db	44h		; WR4
	db	60h		; WR5
	db	bps9600		; WR12
	db	bps9600 shr 8	; WR13
	db	0		; WR15

	dw	0		; input modes
	dw	0		; output modes
	dw	0		; control modes
	dw	0		; local modes
	db	0		; line discipline

	dw	0		; Txq head
	dw	0		; Txq tail
	dw	Txb_size-1	; Txq mask
	dw	offset line1_Txb	; Txq buffer offset

	dw	0		; Rxq head
	dw	0		; Rxq tail
	dw	Rxb_size-1	; Rxq mask
	dw	offset line1_Rxb	; Rxq buffer offset

	dw	0		; Auxq head
	dw	0		; Auxq tail
	dw	Auxb_size-1	; Auxq mask
	dw	offset line1_Auxb	; Aux buffer offset

	dw	-1		; primary device data block size
	dw	0		; auxiliary device data block size
	db	_prefix_len dup (?)	; auxiliary device prefix string
	db	_suffix_len dup (?)	; auxiliary device suffix string

	dw	-1		; primary device data count
	dw	0		; auxiliary device data count
	dw	0		; prefix/suffix pointer

; line 2
	dw	84h		; base I/O address
	dw	0		; line status
	dw	0		; transmit procedure
	db	80h		; channel reset command
	db	0		; modem status control value

	db	90h		; WR2
	db	0c0h		; WR3
	db	44h		; WR4
	db	60h		; WR5
	db	bps9600		; WR12
	db	bps9600 shr 8	; WR13
	db	0		; WR15

	dw	0		; input modes
	dw	0		; output modes
	dw	0		; control modes
	dw	0		; local modes
	db	0		; line discipline

	dw	0		; Txq head
	dw	0		; Txq tail
	dw	Txb_size-1	; Txq mask
	dw	offset line2_Txb	; Txq buffer offset

	dw	0		; Rxq head
	dw	0		; Rxq tail
	dw	Rxb_size-1	; Rxq mask
	dw	offset line2_Rxb	; Rxq buffer offset

	dw	0		; Auxq head
	dw	0		; Auxq tail
	dw	Auxb_size-1	; Auxq mask
	dw	offset line2_Auxb	; Aux buffer offset

	dw	-1		; primary device data block size
	dw	0		; auxiliary device data block size
	db	_prefix_len dup (?)	; auxiliary device prefix string
	db	_suffix_len dup (?)	; auxiliary device suffix string

	dw	-1		; primary device data count
	dw	0		; auxiliary device data count
	dw	0		; prefix/suffix pointer

; line 3
	dw	80h		; base I/O address
	dw	0		; line status
	dw	0		; transmit procedure
	db	40h		; channel reset command
	db	0		; modem status control value

	db	90h		; WR2
	db	0c0h		; WR3
	db	44h		; WR4
	db	60h		; WR5
	db	bps9600		; WR12
	db	bps9600 shr 8	; WR13
	db	0		; W15

	dw	0		; input modes
	dw	0		; output modes
	dw	0		; control modes
	dw	0		; local modes
	db	0		; line discipline

	dw	0		; Txq head
	dw	0		; Txq tail
	dw	Txb_size-1	; Txq mask
	dw	offset line3_Txb	; Txq buffer offset

	dw	0		; Rxq head
	dw	0		; Rxq tail
	dw	Rxb_size-1	; Rxq mask
	dw	offset line3_Rxb	; Rxq buffer offset

	dw	0		; Auxq head
	dw	0		; Auxq tail
	dw	Auxb_size-1	; Auxq mask
	dw	offset line3_Auxb	; Aux buffer offset

	dw	-1		; primary device data block size
	dw	0		; auxiliary device data block size
	db	_prefix_len dup (?)	; auxiliary device prefix string
	db	_suffix_len dup (?)	; auxiliary device suffix string

	dw	-1		; primary device data count
	dw	0		; auxiliary device data count
	dw	0		; prefix/suffix pointer

; line 4
	dw	104h		; base I/O address
	dw	0		; line status
	dw	0		; transmit procedure
	db	80h		; channel reset command
	db	0		; modem status control value

	db	0a0h		; WR2
	db	0c0h		; WR3
	db	44h		; WR4
	db	60h		; WR5
	db	bps9600		; WR12
	db	bps9600 shr 8	; WR13
	db	0		; WR15

	dw	0		; input modes
	dw	0		; output modes
	dw	0		; control modes
	dw	0		; local modes
	db	0		; line discipline

	dw	0		; Txq head
	dw	0		; Txq tail
	dw	Txb_size-1	; Txq mask
	dw	offset line4_Txb	; Txq buffer offset

	dw	0		; Rxq head
	dw	0		; Rxq tail
	dw	Rxb_size-1	; Rxq mask
	dw	offset line4_Rxb	; Rxq buffer offset

	dw	0		; Auxq head
	dw	0		; Auxq tail
	dw	Auxb_size-1	; Auxq mask
	dw	offset line4_Auxb	; Aux buffer offset

	dw	-1		; primary device data block size
	dw	0		; auxiliary device data block size
	db	_prefix_len dup (?)	; auxiliary device prefix string
	db	_suffix_len dup (?)	; auxiliary device suffix string

	dw	-1		; primary device data count
	dw	0		; auxiliary device data count
	dw	0		; prefix/suffix pointer

; line 5
	dw	100h		; base I/O address
	dw	0		; line status
	dw	0		; transmit procedure
	db	40h		; channel reset command
	db	0		; modem status control value

	db	0a0h		; WR2
	db	0c0h		; WR3
	db	44h		; WR4
	db	60h		; WR5
	db	bps9600		; WR12
	db	bps9600 shr 8	; WR13
	db	0		; WR15

	dw	0		; input modes
	dw	0		; output modes
	dw	0		; control modes
	dw	0		; local modes
	db	0		; line discipline

	dw	0		; Txq head
	dw	0		; Txq tail
	dw	Txb_size-1	; Txq mask
	dw	offset line5_Txb	; Txq buffer offset

	dw	0		; Rxq head
	dw	0		; Rxq tail
	dw	Rxb_size-1	; Rxq mask
	dw	offset line5_Rxb	; Rxq buffer offset

	dw	0		; Auxq head
	dw	0		; Auxq tail
	dw	Auxb_size-1	; Auxq mask
	dw	offset line5_Auxb	; Aux buffer offset

	dw	-1		; primary device data block size
	dw	0		; auxiliary device data block size
	db	_prefix_len dup (?)	; auxiliary device prefix string
	db	_suffix_len dup (?)	; auxiliary device suffix string

	dw	-1		; primary device data count
	dw	0		; auxiliary device data count
	dw	0		; prefix/suffix pointer

; line 6
	dw	184h		; base I/O address
	dw	0		; line status
	dw	0		; transmit procedure
	db	80h		; channel reset command
	db	0		; modem status control value

	db	0b0h		; WR2
	db	0c0h		; WR3
	db	44h		; WR4
	db	60h		; WR5
	db	bps9600		; WR12
	db	bps9600 shr 8	; WR13
	db	0		; WR15

	dw	0		; input modes
	dw	0		; output modes
	dw	0		; control modes
	dw	0		; local modes
	db	0		; line discipline

	dw	0		; Txq head
	dw	0		; Txq tail
	dw	Txb_size-1	; Txq mask
	dw	offset line6_Txb	; Txq buffer offset

	dw	0		; Rxq head
	dw	0		; Rxq tail
	dw	Rxb_size-1	; Rxq mask
	dw	offset line6_Rxb	; Rxq buffer offset

	dw	0		; Auxq head
	dw	0		; Auxq tail
	dw	Auxb_size-1	; Auxq mask
	dw	offset line6_Auxb	; Aux buffer offset

	dw	-1		; primary device data block size
	dw	0		; auxiliary device data block size
	db	_prefix_len dup (?)	; auxiliary device prefix string
	db	_suffix_len dup (?)	; auxiliary device suffix string

	dw	-1		; primary device data count
	dw	0		; auxiliary device data count
	dw	0		; prefix/suffix pointer

; line 7
	dw	180h		; base I/O address
	dw	0		; line status
	dw	0		; transmit procedure
	db	40h		; channel reset command
	db	0		; modem status control value

	db	0b0h		; WR2
	db	0c0h		; WR3
	db	44h		; WR4
	db	60h		; WR5
	db	bps9600		; WR12
	db	bps9600 shr 8	; WR13
	db	0		; WR15

	dw	0		; input modes
	dw	0		; output modes
	dw	0		; control modes
	dw	0		; local modes
	db	0		; line discipline

	dw	0		; Txq head
	dw	0		; Txq tail
	dw	Txb_size-1	; Txq mask
	dw	offset line7_Txb	; Txq buffer offset

	dw	0		; Rxq head
	dw	0		; Rxq tail
	dw	Rxb_size-1	; Rxq mask
	dw	offset line7_Rxb	; Rxq buffer offset

	dw	0		; Auxq head
	dw	0		; Auxq tail
	dw	Auxb_size-1	; Auxq mask
	dw	offset line7_Auxb	; Aux buffr offset

	dw	-1		; primary device data block size
	dw	0		; auxiliary device data block size
	db	_prefix_len dup (?)	; auxiliary device prefix string
	db	_suffix_len dup (?)	; auxiliary device suffix string

	dw	-1		; primary device data count
	dw	0		; auxiliary device data count
	dw	0		; prefix/suffix pointer

	public	com_data_end
com_data_end	equ	$
	db	0ffh		; end of data

data	ends
	end
